/*******************************************************************
 * Xatm -- OCF, CID, TrueType scalable font support for X 
 *  By: $B2#ED(B $BM5;W(B <y5t0964@students.chiba-u.ac.jp>
 */

/* $Id: metric.c,v 1.5 1998/04/01 09:37:43 elca Exp $ */

/* metric.c: $BJ8;z$NBg$-$5$r7W;;$9$k(B */

#include <math.h>
#include "metric.h"

/* $B>.?tE@0J2<;M<N8^F~(B */
int d_to_i(double d)
{
	return (int)(d + 0.5);
}

double fmin(double a, double b)
{
	if(a < b) {
		return a;
	}
	return b;
}

double fmin4(double a, double b, double c, double d)
{
	return fmin(fmin(a, b), fmin(c, d));
}

double fmax(double a, double b)
{
	if(a > b) {
		return a;
	}
	return b;
}

double fmax4(double a, double b, double c, double d)
{
	return fmax(fmax(a, b), fmax(c, d));
}

/* $BJ8;z$NI}(B */
double computeWidth(double matrix[4])
{
	return fmax4(0.0, matrix[0], matrix[2], matrix[0]+matrix[2])
		- fmin4(0.0, matrix[0], matrix[2], matrix[0]+matrix[2]);
}

/* $BJ8;z$N9b$5(B */
double computeHeight(double matrix[4])
{
	return fmax4(0.0, matrix[1], matrix[3], matrix[1]+matrix[3])
		- fmin4(0.0, matrix[1], matrix[3], matrix[1]+matrix[3]);
}

/* $BJ8;z$NAw$jI}(B */
double computeChWidth(double matrix[4])
{
	return fmax(fabs(matrix[0]), fabs(matrix[2]));
}

/* $B9TAw$jI}(B */
double computeChHeight(double matrix[4])
{
	return fmax(fabs(matrix[1]), fabs(matrix[3]));
}


/* $BJ8;z$N:82<3Q$H:BI8(B (0,0) $B$H$N$:$l(B */
double computeXdelta(double matrix[4])
{
	return fabs(fmin4(0.0, matrix[0], matrix[2], matrix[0]+matrix[2]));
}

/* $BJ8;z$N:82<3Q$H:BI8(B (0,0) $B$H$N$:$l(B */
double computeYdelta(double matrix[4])
{
	return fabs(fmin4(0.0, matrix[1], matrix[3], matrix[1]+matrix[3]));
}

/* end */
